using System;
using System.Collections.Generic;
using System.Text;

namespace MaxiBioWindowsApplication
{
    public class Biograf
    {
        #region felter for selve Biograf klassen 
        private string biografnavn;
        #endregion
        
        #region properties og metoder selve MaxiBio
        public Biograf(string initBiografnavn)
        {
            this.biografnavn = initBiografnavn;
        }
        public string Biografnavn
        {
            get { return this.biografnavn; }
            set { this.biografnavn = value; }
        }
        public override string ToString()
        {
            return this.biografnavn;
        }
        #endregion

        #region data og metoder for Biografens's tilhrende Biografsale

        private List<Biografsal> biografsalListe = new List<Biografsal>();
        
        // Opretter ny sal i biografen:
        public Biografsal OpretBiografsal(string navn, bool thx, int antalPladser)
        {
            Biografsal nyBiografsal = new Biografsal(navn, thx, antalPladser);
            this.biografsalListe.Add(nyBiografsal);
            return nyBiografsal;
        }
        
        // Find film efter titel:
        public Biografsal FindBiografsal(string sgeNavn)
        {
            foreach (Biografsal enBiografsal in this.biografsalListe)
            {
                if (enBiografsal.Navn.ToLower().Contains(sgeNavn.ToLower()))
                {
                    return enBiografsal;
                }
            }
            return null;
        }

        public Biografsal[] HentAlleBiografsale()
        {
            return this.biografsalListe.ToArray();
        }

        #endregion

        #region afledte metoder vedrrende Forestillinger
        // Biograf klassen kan via sine Biografsale vre expert p tvrs af disse

        // Find foretillinger efter dato 
        public Forestilling[] FindForestillinger(int sgeDato)
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biografsal enBiografsal in this.biografsalListe)
            {
                Forestilling[] salensForestiller = 
                    enBiografsal.FindForestillinger(sgeDato);
                
                fundneForestillinger.AddRange(salensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        // Find foretillinger i periode 
        public Forestilling[] FindForestillinger(int startDato, int slutDato)
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biografsal enBiografsal in this.biografsalListe)
            {
                Forestilling[] salensForestiller =
                    enBiografsal.FindForestillinger(startDato, slutDato);

                fundneForestillinger.AddRange(salensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        public Forestilling[] HentAlleForestillinger()
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biografsal enBiografsal in this.biografsalListe)
            {
                Forestilling[] salensForestiller =
                    enBiografsal.HentAlleForestillinger();

                fundneForestillinger.AddRange(salensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        #endregion
    }
}
