using System;
using System.Collections.Generic;
using System.Text;

namespace MaxiBioWindowsApplication
{
    public class MaxBio
    {
        #region felter for selve MaxiBio klassen
        private string firmanavn;
        #endregion
        
        #region properties og metoder selve MaxiBio klassen
        public MaxBio()
        {
            this.firmanavn = "MaxiBio";
        }
        public string Firmanavn
        {
            get { return this.firmanavn; }
            set { this.firmanavn = value; }
        }
        public override string ToString()
        {
            return this.firmanavn;
        }
        #endregion

        #region data og metoder for MaxiBio's tilhrende film

        private List<Film> filmListe = new List<Film>();
        
        // Opretter ny film i filmsamlingen:
        public Film OpretFilm(string titel, string genre, string skuespillere, string resume, int varighed, bool thx)
        {
            Film nyFilm = new Film(titel, genre, skuespillere, resume, varighed, thx);
            this.filmListe.Add(nyFilm);
            return nyFilm;
        }
        
        // Find film efter titel:
        public Film FindFilm(string sgeTitel)
        {
            foreach (Film enFilm in this.filmListe )
            {
                if (enFilm.Titel.ToLower().Contains(sgeTitel.ToLower()))
                {
                    return enFilm;
                }
            }
            return null;
        }
        
        public Film[] HentAlleFilm()
        {
            return this.filmListe.ToArray();
        }

        #endregion
        
        #region data og metoder for MaxiBio's tilhrende Biografer

        private List<Biograf> biografListe = new List<Biograf>();

        // Opretter ny biograf
        public Biograf OpretBiograf(string biografnavn)
        {
            Biograf nyBiograf = new Biograf(biografnavn);
            this.biografListe.Add(nyBiograf);
            return nyBiograf;
        }

        // Find biograf p navn
        public Biograf FindBiograf(string sgeNavn)
        {
            foreach (Biograf enBiograf in this.biografListe)
            {
                if (enBiograf.Biografnavn.ToLower().Contains(sgeNavn.ToLower()))
                {
                    return enBiograf;
                }
            }
            return null;
        }

        public Biograf[] HentAlleBiografer()
        {
            return this.biografListe.ToArray();
        }

        #endregion

        #region afledte metoder vedrrende Forestillinger
        // Biograf klassen kan via sine Biografer vre expert p tvrs af disse

        // Find foretillinger efter dato 
        public Forestilling[] FindForestillinger(int sgeDato)
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biograf enBiograf in this.biografListe)
            {
                Forestilling[] biografensForestiller =
                    enBiograf.FindForestillinger(sgeDato);

                fundneForestillinger.AddRange(biografensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        // Find foretillinger i periode 
        public Forestilling[] FindForestillinger(int startDato, int slutDato)
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biograf enBiograf in this.biografListe)
            {
                Forestilling[] biografensForestiller =
                    enBiograf.FindForestillinger(startDato, slutDato);

                fundneForestillinger.AddRange(biografensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        public Forestilling[] HentAlleForestillinger()
        {
            List<Forestilling> fundneForestillinger = new List<Forestilling>();
            foreach (Biograf enBiograf in this.biografListe)
            {
                Forestilling[] biografensForestiller =
                    enBiograf.HentAlleForestillinger();

                fundneForestillinger.AddRange(biografensForestiller);
                // AddRange lber samlingen igennem og udfrer add p hvert element
            }
            return fundneForestillinger.ToArray();
        }

        #endregion

    }
}
